<?php
/**
 * ManuAdminMod
 *
 * This is a powerful and platform independent software for administrating game servers of various kinds.
 * If you need help with installing or using this software, please visit our website at: www.ManuAdminMod.de
 * If you want to obtain additional permissions extending the license, contact us at: Webmaster@ManuAdminMod.de
 *
 * @copyright www.ManuAdminMod.de
 * @license http://www.creativecommons.org/licenses/by-nc-nd/4.0/ Creative Commons BY-NC-ND 4.0
 * @version 1.0.0-Beta+7
**/

namespace MAM\Daemon\Api;

use MAM\Daemon\Core\Registry;

class TcpClient {
    protected $in_buffer = '';
    private $socket;
    protected $logging;
    /**
     * @var TcpServer
     */
    private $tcp_server;

    public function __construct($socket, $tcp_server) {
        $this->logging = Registry::getInstance()->logging;
        $this->socket = $socket;
        $this->tcp_server = $tcp_server;
    }

    public function getSocket() {
        return $this->socket;
    }

    public function getInBuffer() {
        return $this->in_buffer;
    }

    public function appendInBuffer($append) {
        $this->in_buffer .= $append;
    }

    public function writeToSocket($data) {
        for ($written = 0; $written < strlen($data); $written += $fwrite) {
            $fwrite = fwrite($this->socket, substr($data, $written));
            if ($fwrite === 0) {
                $this->logging->warning('API TCP client: writing to socket failed');
            }
        }
    }

    public function disconnectClient() {
        stream_socket_shutdown($this->socket, STREAM_SHUT_RDWR);
        $this->tcp_server->removeClient($this);
    }

}
