<?php
/**
 * ManuAdminMod
 *
 * This is a powerful and platform independent software for administrating game servers of various kinds.
 * If you need help with installing or using this software, please visit our website at: www.ManuAdminMod.de
 * If you want to obtain additional permissions extending the license, contact us at: Webmaster@ManuAdminMod.de
 *
 * @copyright www.ManuAdminMod.de
 * @license http://www.creativecommons.org/licenses/by-nc-nd/4.0/ Creative Commons BY-NC-ND 4.0
 * @version 1.0.0-Beta+7
**/

namespace MAM\Plugins\Punishmenttest;

use MAM\Daemon\Core\Utils;

class Punishmenttest extends Utils {

    public function __construct() {
        parent::__construct();
    }

    public function initPlugin() {
        parent::initPlugin();
        $this->mod->setDefaultCV("punishmenttest", "enabled", 1);
        $this->mod->registerCommand("test", '~^test .+$~i', "test", $this);
        $this->mod->registerCommand("view", '~^view .+$~i', "view", $this);
      //  $this->mod->registerEvent("playerJoined", "banTest", $this);
    }

    public function test($guid, $parameters) {
        if (!$this->mod->getCV("punishmenttest", "enabled")) {
            return false;
        }

        $this->players[$guid]->punishmentScoreAdd($parameters[0]);

        $action = $this->registry->punishment->checkScore($this->players[$guid]->getPunishmentScore(), $parameters[0]);
        if ($action !== false) {
            $this->registry->punishment->punish($guid, $action, $parameters[0], array("reason" => false, "kicker" => false));
        }
    }

    public function view($guid, $parameters) {
        $score = $this->players[$this->mod->findPlayerGuid($parameters[0])]->getPunishmentScore();
        $this->players[$guid]->say("Player " . $this->players[$this->mod->findPlayerGuid($parameters[0])]->getName() . " has $score punishment points");
    }


    public function banTest($guid){
        $this->players[$guid]->ban("Ban Test");
    }
}
