<?php
/**
 * ManuAdminMod
 *
 * This is a powerful and platform independent software for administrating game servers of various kinds.
 * If you need help with installing or using this software, please visit our website at: www.ManuAdminMod.de
 * If you want to obtain additional permissions extending the license, contact us at: Webmaster@ManuAdminMod.de
 *
 * @copyright www.ManuAdminMod.de
 * @license http://www.creativecommons.org/licenses/by-nc-nd/4.0/ Creative Commons BY-NC-ND 4.0
 * @version 1.0.0-Beta+7
**/

namespace MAM\Plugins\Tcp;

/**
 * TCP Console
 *
 * This Class includes all player realted functions for the tcp console.
 *
 * @author manu
 */
class Player {
    /**
     * Name
     *
     * @var string 
     */
    private $name;
    /**
     * Group
     *
     * @var string 
     */
    private $group;
    /**
     * Conenction
     *
     * @var mixed 
     */
    private $connection;
    /**
     * Joined
     *
     * @var int 
     */
    public $joined = 0;
    /**
     * Class for mam related stuff
     *
     * @var \MAM\Daemon\Core\Mod
     */
    private $mod;
    /**
     * Class for Remote Commands
     *
     * @var \MAM\Daemon\Engine\Quake3\Rcon\RconCommands
     */
    private $rcon;
    /**
     * Class for player related stuff
     *
     * @var \MAM\Daemon\Core\Player
     */
    private $players;
    /**
     * Class for Logging
     *
     * @var \MAM\Daemon\Libraries\Logging\LogHandler
     */
    private $logging;

    /**
     * Constructor
     * 
     * @param String $name
     * @param String $group
     * @param String $connection
     */
    public function __construct($name, $group, &$connection) {
        $registry = \MAM\Daemon\Core\Registry::getInstance();
        $this->mod = $registry->mod;
        $this->players = &$registry->players;
        $this->rcon = $registry->rcon;
        $this->logging = $registry->logging;


        $this->name = $name;
        $this->group = $group;
        $this->connection = & $connection;
        $this->joined = time();
    }

    /**
     *  __set
     * 
     * @param String $name
     * @param String $value
     */
    public function __set($name, $value) {
        
    }

    /**
     * __get
     * 
     * @param String $name
     * @return int
     */
    public function __get($name) {
        return 0;
    }

    /**
     * __call
     * 
     * @param string $name
     * @param array $arguments
     * @return int
     */
    public function __call($name, $arguments) {
        return 0;
    }

    /**
     * get Group
     * 
     * @return string
     */
    public function getGroup() {
        return $this->group;
    }

    /**
     * get Name
     * 
     * @return string
     */
    public function getName() {
        return "TCP-Admin ($this->name)";
    }

    /**
     * get PID
     * 
     * @return string
     */
    public function getPID() {
        return "X";
    }

    /**
     * get GUID
     * 
     * @return string
     */
    public function getGuid() {
        return "TCPUSER";
    }

    /**
     * is allowed to execute name
     * 
     * @param string $command
     * @return boolean
     */
    public function isAllowedToExec($command) {
        if (in_array($command, $this->mod->getCV("tcp_query", "disallowedcommands"))) {
            return false;
        }
        return in_array($command, $this->mod->getGroupCommands($this->getGroup()));
    }

    /**
     * get allowed commands
     * 
     * @return array
     */
    public function getAllowedCommands() {
        $commands = array();
        return $this->mod->getGroupCommands($this->getGroup());
    }

    /**
     * say
     * 
     * @param string $msg
     */
    public function say($msg) {
        $msg = str_replace("{{br}}", "\n", $msg) . "\n";
        $this->connection->write($msg, \MAM\Plugins\Tcp\TcpLevel::MT_PM);
    }
}
